#import "BarcodeOptionViewController.h"
#import "SystemSetting.h"
#import "LongRange2DManager.h"
@interface BarcodeOptionViewController ()<LongRange2DManagerDelegate>
@property (weak, nonatomic) IBOutlet UITableView *tableView;
@property (strong, nonatomic) NSArray *barcodeParamData;
@end

@implementation BarcodeOptionViewController{
    SystemSetting * systemSetting;
    LongRange2DManager *_longRange2DManager;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    _longRange2DManager = [LongRange2DManager sharedLongRange2DManager];
    [LongRange2DManager showGlobalProgressHUDWithTitle:@"Loading..."];
    
    systemSetting = [SystemSetting sharedSystemSetting];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
-(void)viewDidAppear:(BOOL)animated{
    [_longRange2DManager setDelegate:self];
    NSMutableArray *paramData = [[NSMutableArray alloc] initWithObjects:
                          [NSNumber numberWithInt:LongRange2DUPCA],
                          [NSNumber numberWithInt:LongRange2DUPCE0],
                          [NSNumber numberWithInt:LongRange2DEAN8],
                          [NSNumber numberWithInt:LongRange2DEAN13],
                          [NSNumber numberWithInt:LongRange2DCode128],
                          [NSNumber numberWithInt:LongRange2DCode39],
                          [NSNumber numberWithInt:LongRange2DCode93],
                          [NSNumber numberWithInt:LongRange2DCode11],
                          [NSNumber numberWithInt:LongRange2DI2of5],
                          [NSNumber numberWithInt:LongRange2DCodabar],
                          [NSNumber numberWithInt:LongRange2DMSI],
                          [NSNumber numberWithInt:LongRange2DX2of5],
                          [NSNumber numberWithInt:LongRange2DPDF417],
                          [NSNumber numberWithInt:LongRange2DMicroPDF],
                          [NSNumber numberWithInt:LongRange2DMatrix],
                          [NSNumber numberWithInt:LongRange2DMaxiCode],
                          [NSNumber numberWithInt:LongRange2DQRCode],
                          [NSNumber numberWithInt:LongRange2DAztecCode],
                          [NSNumber numberWithInt:LongRange2DGS1128],
                          [NSNumber numberWithInt:LongRange2DTelepen],
                          [NSNumber numberWithInt:LongRange2DCodablockA],
                          [NSNumber numberWithInt:LongRange2DCodablockF],
                          [NSNumber numberWithInt:LongRange2DJapanPost],
                          [NSNumber numberWithInt:LongRange2DGS1DatabarRSS14],
                          nil];
    if ([systemSetting canUseCenterDecoding:[_longRange2DManager getFirmwareVersion]]) {
        NSArray *addArray = [[NSArray alloc] initWithObjects:
                             [NSNumber numberWithInt:LongRange2DDutchPost],
                             [NSNumber numberWithInt:LongRange2DCanadaPost],
                             [NSNumber numberWithInt:LongRange2DPostnet],
                             [NSNumber numberWithInt:LongRange2DAustralianPost],
                             [NSNumber numberWithInt:LongRange2DGS1CompositeAB],
                             [NSNumber numberWithInt:LongRange2DGS1CompositeC],
                             [NSNumber numberWithInt:LongRange2DPlessey],
                             [NSNumber numberWithInt:LongRange2DBPO],
                             [NSNumber numberWithInt:LongRange2DStandard2of5],
                             [NSNumber numberWithInt:LongRange2DSwedenPost],
                             [NSNumber numberWithInt:LongRange2DPlanet],
                             [NSNumber numberWithInt:LongRange2DGS1DataBarLimited],
                             [NSNumber numberWithInt:LongRange2DGS1DataBarExpanded],
                             [NSNumber numberWithInt:LongRange2DTLC39],
                             nil];
        [paramData addObjectsFromArray:addArray];
    }
    NSMutableArray *arrParam = [[NSMutableArray alloc] init];
    for (NSNumber *paramName in paramData) {
        LongRange2DParamValue * val = [_longRange2DManager getBarcodeParam:(LongRange2DParamNameOptions)[paramName intValue]];
        if(val != nil)
        { 
            [arrParam addObject:val];
        }
    }
//    if ([systemSetting getBarcodeParamData] && [[systemSetting getBarcodeParamData] count] > 0 ) {
//        self.barcodeParamData = (NSArray *)[systemSetting getBarcodeParamData];
//    }else{
        self.barcodeParamData = (NSArray *)arrParam;
//    }
    [self.tableView reloadData];
    [LongRange2DManager dismissGlobalHUD];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [_longRange2DManager setDelegate:nil];
    [_longRange2DManager stopScan];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

#pragma mark - UITableViewDataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.barcodeParamData.count;
}

#pragma mark - UITableViewDelegate
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"BarcodeCell" forIndexPath:indexPath];
    
    LongRange2DParamValue *paramValue = [self.barcodeParamData objectAtIndex:indexPath.row];
    cell.textLabel.text = [LongRange2DParamName getName:paramValue.paramName];

    if (paramValue.value) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    LongRange2DParamValue *paramValue = [self.barcodeParamData objectAtIndex:indexPath.row];
    
    if (cell.accessoryType == UITableViewCellAccessoryCheckmark) {
        cell.accessoryType = UITableViewCellAccessoryNone;
        paramValue.value = 0;
    } else {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
        paramValue.value = 1;
    }
}

- (IBAction)defaultAllSymBtnTapped:(id)sender {
    for (LongRange2DParamValue *paramValue in self.barcodeParamData) {
        switch(paramValue.paramName) {
            case LongRange2DUPCA:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DUPCE0:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DEAN8:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DEAN13:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DCode128:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DCode39:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DCode93:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DCode11:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DI2of5:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DCodabar:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DMSI:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DX2of5:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DPDF417:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DMicroPDF:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DMatrix:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DMaxiCode:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DQRCode:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DAztecCode:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DGS1128:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DTelepen:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DCodablockA:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DCodablockF:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DJapanPost:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DGS1DatabarRSS14:
                [paramValue setEnabled:YES];
                break;
            case LongRange2DDutchPost:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DCanadaPost:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DPostnet:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DAustralianPost:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DGS1CompositeAB:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DGS1CompositeC:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DPlessey:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DBPO:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DStandard2of5:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DSwedenPost:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DPlanet:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DGS1DataBarLimited:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DGS1DataBarExpanded:
                [paramValue setEnabled:NO];
                break;
            case LongRange2DTLC39:
                [paramValue setEnabled:NO];
                break;
            default:
                break;
        }

    }
    [self.tableView reloadData];
}

- (IBAction)disableAllSymBtnTapped:(id)sender {
    for (LongRange2DParamValue *paramValue in self.barcodeParamData) {
        [paramValue setEnabled:NO];
    }
    [self.tableView reloadData];
}

- (IBAction)enableAllSymBtnTapped:(id)sender {
    for (LongRange2DParamValue *paramValue in self.barcodeParamData) {
        [paramValue setEnabled:YES];
    }
    [self.tableView reloadData];
}

- (IBAction)saveSymBtnTapped:(id)sender {
    LongRange2DResultCode res = LongRange2DResultNoError;
    [LongRange2DManager showGlobalProgressHUDWithTitle:@"Saving..."];

    for (LongRange2DParamValue *paramName in self.barcodeParamData) {
        res = [_longRange2DManager setBarcodeParam:paramName];
        if (res != LongRange2DResultNoError) {
            [LongRange2DManager dismissGlobalHUD];
            return;
        }
    }
    [LongRange2DManager dismissGlobalHUD];
    if (res == LongRange2DResultNoError) {
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Success" message:@"Saved successfully" preferredStyle:(UIAlertControllerStyleAlert)];
        UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
        }];
        [alertController addAction:action];
        [self presentViewController:alertController animated:YES completion:nil];
    } else {
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Error" message:@"Failed to save" preferredStyle:(UIAlertControllerStyleAlert)];
        UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
        }];
        [alertController addAction:action];
        [self presentViewController:alertController animated:YES completion:nil];
    }
    [systemSetting setBarcodeParamData:self.barcodeParamData];

}

#pragma mark - Reader Event Handler Methods
- (void)updateDeviceState:(LongRange2DResultCode)error {
    if (error != LongRange2DResultNoError) {
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Error" message:@"Failed to get response. Try again." preferredStyle:(UIAlertControllerStyleAlert)];
        UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            [self.navigationController popViewControllerAnimated:YES];
        }];
        [alertController addAction:action];
        [self presentViewController:alertController animated:YES completion:nil];
    }
}

- (void)changedActionState:(LongRange2DCommandType)action resultCode:(NSInteger)resultCode {
    
}
- (void)LongRange2DConnected:(BOOL)isConnected{
    if (!isConnected) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [LongRange2DManager dismissGlobalHUD];
            [self.navigationController popToRootViewControllerAnimated:YES];
        });
    }
}

@end
