//
//  CSVData.m
//  AsReaderLR
//
//  Created by mac on 2017/8/7.
//  Copyright © 2017年 asterisk. All rights reserved.
//

#import "CSVData.h"
#import "AsBarcodeItem.h"
#define maxNumber 100
@interface CSVData()
@end

@implementation CSVData
+ (NSString *) filePath:(NSString *)fileName{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *path = [paths objectAtIndex:0];
    NSString *filePath = [path stringByAppendingPathComponent:fileName];
    return filePath;
}

+ (void) isFileExist {
    NSString *string = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSArray *fileList = [[[NSFileManager defaultManager] contentsOfDirectoryAtPath:string error:nil] pathsMatchingExtensions:@[@"csv"]];
    fileList = [fileList sortedArrayUsingComparator:^NSComparisonResult(id obj1, id obj2) {
        NSString *str1 = obj1;
        NSString *str2 = obj2;
        NSComparisonResult result = [str1 compare:str2];
        return result == NSOrderedDescending;
    }];
    if (fileList && fileList.count >= maxNumber) {
        NSArray * deleteArray = [fileList subarrayWithRange:NSMakeRange(0, fileList.count - maxNumber + 1)];
        [self deleteFileForFileName:deleteArray];
    }
}

+ (void) deleteFileForFileName:(NSArray *)array {
    NSString *extension = @"csv";
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    NSEnumerator *enumerator = [array objectEnumerator];
    NSString *filename;
    while ((filename = [enumerator nextObject])) {
        if ([[filename pathExtension] isEqualToString:extension]) {
            [fileManager removeItemAtPath:[documentsDirectory stringByAppendingPathComponent:filename] error:nil];
        }
    }
}

+ (void) createCSVWithFileName:(NSString *)fileName {
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if (![fileManager createFileAtPath:[self filePath:fileName]  contents:nil attributes:nil]) {
    }
}

+ (void) exportBarCodeCSV:(NSString *)fileName withArray:(NSMutableArray *)array vc:(UIViewController *)vc{
    NSOutputStream *output = [[NSOutputStream alloc] initToFileAtPath:[self filePath:fileName] append:YES];
    [output open];
    
    if (![output hasSpaceAvailable]) {
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:nil message:@"Output Error" preferredStyle:(UIAlertControllerStyleAlert)];
        UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            
        }];
        [alertController addAction:action];
        [vc presentViewController:alertController animated:YES completion:nil];
        return;
    } else {
        NSString *header;
        
        header = @"Barcode,Time,Count\n";
        
        const uint8_t *headerString = (const uint8_t *)[header cStringUsingEncoding:NSUTF8StringEncoding];
        NSInteger headerLength = [header lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
        NSInteger result = [output write:headerString maxLength:headerLength];
        if (result <= 0) {
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:nil message:@"Output Error" preferredStyle:(UIAlertControllerStyleAlert)];
            UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
                
            }];
            [alertController addAction:action];
            [vc presentViewController:alertController animated:YES completion:nil];
            return;
        }
        
        for (AsBarcodeItem *item in array) {
            NSString *row = [NSString stringWithFormat:@"%@,%@,%d\n", item.barcode, item.dateTime, item.count];
            const uint8_t *rowString = (const uint8_t *)[row cStringUsingEncoding:NSUTF8StringEncoding];
            NSInteger rowLength = [row lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
            result = [output write:rowString maxLength:rowLength];
            if (result <= 0) {
                UIAlertController * alertController = [UIAlertController alertControllerWithTitle:nil message:@"Barcode File Output Error" preferredStyle:(UIAlertControllerStyleAlert)];
                UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
                    
                }];
                [alertController addAction:action];
                [vc presentViewController:alertController animated:YES completion:nil];
                return;
            }
        }
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:nil message:@"Barcode File Output Success" preferredStyle:(UIAlertControllerStyleAlert)];
        UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            
        }];
        [alertController addAction:action];
        [vc presentViewController:alertController animated:YES completion:nil];
        [output close];
    }
}

@end
