//
//  UserFilesViewController.m
//  AsCameraScan
//
// Created by Asterisk.Inc on 2018/4/27.
// Copyright © 2018年 Asterisk.Inc. All rights reserved.
#import "UserFilesViewController.h"
#import "XMLHandler.h"
#import "FirmwareInfo.h"
#import "Reachability.h"
#import "MBProgressHUD.h"
#import "LongRange2DManager.h"
#import "FirmwareUpdateManager.h"
#import "SystemSetting.h"
typedef NS_ENUM(NSUInteger, LongRange2DFirmwareMode) {
    LongRange2DRelease =0,
    LongRange2DDebug
};

@interface UserFilesViewController ()<XMLHandlerDelegate,MBProgressHUDDelegate,UITextFieldDelegate,UITableViewDelegate,UITableViewDataSource,LongRange2DManagerDelegate>


@property (weak, nonatomic) IBOutlet UITableView *tableView;
@property (weak, nonatomic) IBOutlet UIView *emptyView;
@property (weak, nonatomic) IBOutlet UIButton *doneButton;
@property (nonatomic,strong) NSString *passwordText;
@end

@implementation UserFilesViewController{
    NSFileManager       * fileManager;
    NSMutableArray      * elements;
    Reachability        * hostReach;
    NSMutableArray      * existFirmwares;
    NSString            * selectFirmware;
    LongRange2DFirmwareMode          firmwareMode;
    LongRange2DManager *_longRange2DManager;
    FirmwareUpdateManager *_firmwareUpdateManager;
    MBProgressHUD      *pregressHUD;
    BOOL alertControllIsPresenting;
    BOOL needPopToRoot;
}

@synthesize tableView;
@synthesize emptyView;

- (void)viewDidLoad{
    [super viewDidLoad];
    _longRange2DManager = [LongRange2DManager sharedLongRange2DManager];
    _firmwareUpdateManager = [FirmwareUpdateManager sharedFirmwareUpdateManager];
    _passwordText = @"";
    self.doneButton.hidden = YES;

    UIButton *SyncBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [SyncBtn setTitle:NSLocalizedStringFromTable(@"Sync", @"InfoPlist",Nil) forState:UIControlStateNormal];
    [SyncBtn setTitleColor:[UIColor colorWithRed:29/255.0 green:119/255.0 blue:232/255.0 alpha:1] forState:UIControlStateNormal];
    SyncBtn.frame = CGRectMake(0, 0,60, 60);
    [SyncBtn addTarget:self action:@selector(downloadFirmware:) forControlEvents:UIControlEventTouchUpInside];
    UIBarButtonItem * rightItem = [[UIBarButtonItem alloc] initWithCustomView:SyncBtn];
    self.navigationItem.rightBarButtonItem = rightItem;

    elements = [NSMutableArray array];
    existFirmwares=[NSMutableArray array];
    [[XMLHandler sharedAsRingHandler]setDelegate:self];
    fileManager = [NSFileManager defaultManager];
    hostReach = [Reachability reachabilityWithHostName:@"www.apple.com"];
    [hostReach startNotifier];
    LongRange2DNetworkStatus netStatus = [hostReach currentReachabilityStatus];
    NSString *xmlFilePath=[NSString stringWithFormat:@"%@/%@",ROOTPATH,XMLNAME];
    
    if (netStatus != LongRange2DNotReachable &&![fileManager fileExistsAtPath:xmlFilePath]) {
        [self downloadAsRingFWXMLAndBinDataWithBoth:NO];
    }else{
        NSURL *pathUrl = [NSURL fileURLWithPath:xmlFilePath];
        [[XMLHandler sharedAsRingHandler]getFirmwareInfoWithURL:pathUrl];
    }
    
    UILongPressGestureRecognizer *longPressGR = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(longPressAction:)];
    longPressGR.minimumPressDuration=2;
    [self.view addGestureRecognizer:longPressGR];
}
- (void)viewDidAppear:(BOOL)animated{
    [super viewDidAppear:animated];
    [_longRange2DManager  setDelegate:self];
    [LongRange2DManager dismissGlobalHUD];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [_longRange2DManager  setDelegate:nil];
}
-(void)longPressAction:(UILongPressGestureRecognizer *)gesture{
    if ([gesture state]==UIGestureRecognizerStateBegan) {
        alertControllIsPresenting = YES;
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Debug Mode", @"InfoPlist",Nil) message:NSLocalizedStringFromTable(@"Please input password", @"InfoPlist",Nil) preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction* defoultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil)
                                                  style:UIAlertActionStyleDefault
                                                handler:^(UIAlertAction *action) {
                                                    [self checkPassword];
                                                }];
        
        UIAlertAction* cancelAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Cancel", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                             handler:^(UIAlertAction * action) {
                                                                NSLog(@"Cancel");
                                                             }];
        [alert addAction:defoultAction];
        [alert addAction:cancelAction];
        [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
            textField.secureTextEntry = YES;
            textField.delegate = self;
        }];
        [self presentViewController:alert animated:YES completion:^{
            dispatch_async(dispatch_get_main_queue(), ^{
                [NSThread sleepForTimeInterval:1.0];
                self->alertControllIsPresenting = NO;
                if (self->needPopToRoot) {
                    [self.navigationController popToRootViewControllerAnimated:YES];
                }
            });
        }];
    }
}

- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    _passwordText = textField.text;
    return YES;
}
- (void)checkPassword{
        if ([_passwordText isEqualToString:@"123456"]) {
            alertControllIsPresenting = YES;
            UIAlertController* alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Success", @"InfoPlist",Nil)
                                                                           message:NSLocalizedStringFromTable(@"Debug mode is on success.", @"InfoPlist",Nil)
                                                                    preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                                  handler:^(UIAlertAction * action) {
                                                                      self->firmwareMode=LongRange2DDebug;
                                                                      NSString *xmlFilePath=[NSString stringWithFormat:@"%@/%@",ROOTPATH,XMLNAME];
                                                                      NSURL *pathUrl = [NSURL fileURLWithPath:xmlFilePath];
                                                                      [[XMLHandler sharedAsRingHandler]getFirmwareInfoWithURL:pathUrl];
                                                                  }];
            [alert addAction:defaultAction];
            [self presentViewController:alert animated:YES completion:^{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [NSThread sleepForTimeInterval:1.0];
                    self->alertControllIsPresenting = NO;
                    if (self->needPopToRoot) {
                        [self.navigationController popToRootViewControllerAnimated:YES];
                    }
                });
            }];
        }else{
            alertControllIsPresenting = YES;
            UIAlertController* alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Error", @"InfoPlist",Nil)
                                                                           message:NSLocalizedStringFromTable(@"Password error.", @"InfoPlist",Nil)
                                                                    preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil)style:UIAlertActionStyleDefault
                                                                  handler:^(UIAlertAction * action) {}];
            [alert addAction:defaultAction];
            [self presentViewController:alert animated:YES completion:^{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [NSThread sleepForTimeInterval:1.0];
                    self->alertControllIsPresenting = NO;
                    if (self->needPopToRoot) {
                        [self.navigationController popToRootViewControllerAnimated:YES];
                    }
                });
            }];
        }
        //TODO
}
- (void)downloadFirmware:(UIButton *)button{
    [self downloadAsRingFWXMLAndBinDataWithBoth:YES];
}
-(void)downloadAsRingFWXMLAndBinDataWithBoth:(BOOL)both{
    dispatch_async(dispatch_get_main_queue(), ^{
        [LongRange2DManager showGlobalProgressHUDWithTitle:@"Downloading..."];
    });
    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@%@",SERVICERPATH,XMLNAME]];
    NSURLSession *session = [NSURLSession sharedSession];
    NSURLSessionDownloadTask *task = [session downloadTaskWithURL:url completionHandler:^(NSURL * _Nullable location, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if (error) {
            dispatch_async(dispatch_get_main_queue(), ^{
                self->alertControllIsPresenting = YES;
                UIAlertController* alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Error", @"InfoPlist",Nil)
                                                                               message:NSLocalizedStringFromTable(@"Download firmware failed", @"InfoPlist",Nil)
                                                                        preferredStyle:UIAlertControllerStyleAlert];
                UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                                      handler:^(UIAlertAction * action) {
                                                                      }];
                [alert addAction:defaultAction];
                [self presentViewController:alert animated:YES completion:^{
                    dispatch_async(dispatch_get_main_queue(), ^{
                        [NSThread sleepForTimeInterval:1.0];
                        self->alertControllIsPresenting = NO;
                        if (self->needPopToRoot) {
                            [self.navigationController popToRootViewControllerAnimated:YES];
                        }
                    });
                }];
                [LongRange2DManager dismissGlobalHUD];
                return ;
            });
        }else{
            NSString *path = [ROOTPATH stringByAppendingPathComponent:response.suggestedFilename];
            NSURL *pathUrl = [NSURL fileURLWithPath:path];
            if ([self->fileManager fileExistsAtPath:path]) {
                [self->fileManager removeItemAtPath:path error:nil];
            }
            [[NSFileManager defaultManager] moveItemAtURL:location toURL:pathUrl error:nil];
            [[XMLHandler sharedAsRingHandler]getFirmwareInfoWithURL:pathUrl];
            if (both) {
                [self downloadFirmware];
            }else{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [LongRange2DManager dismissGlobalHUD];
                });
            }
        }
    }];
    [task resume];
}
-(void)downloadFirmware{
    if (elements.count>0) {
        FirmwareInfo *firmwareInfo=elements[0];
        NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@%@",SERVICERPATH,firmwareInfo.firmwareName]];
        NSURLSession *session = [NSURLSession sharedSession];
        NSURLSessionDownloadTask *task =[session downloadTaskWithURL:url completionHandler:^(NSURL * _Nullable location, NSURLResponse * _Nullable response, NSError * _Nullable error) {
            if (error) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    self->alertControllIsPresenting = YES;
                    UIAlertController* alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Error", @"InfoPlist",Nil)
                                                                                   message:NSLocalizedStringFromTable(@"Download firmware failed", @"InfoPlist",Nil)
                                                                            preferredStyle:UIAlertControllerStyleAlert];
                    UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                                          handler:^(UIAlertAction * action) {
                                                                          }];
                    [alert addAction:defaultAction];
                    [self presentViewController:alert animated:YES completion:^{
                        dispatch_async(dispatch_get_main_queue(), ^{
                            [NSThread sleepForTimeInterval:1.0];
                            self->alertControllIsPresenting = NO;
                            if (self->needPopToRoot) {
                                [self.navigationController popToRootViewControllerAnimated:YES];
                            }
                        });
                    }];
                    [LongRange2DManager dismissGlobalHUD];
                    return ;
                });
            }else{
                NSString *path = [ROOTPATH stringByAppendingPathComponent:response.suggestedFilename];
                NSURL *pathUrl = [NSURL fileURLWithPath:path];
                [self->fileManager removeItemAtPath:path error:nil];
                [[NSFileManager defaultManager] moveItemAtURL:location toURL:pathUrl error:nil];
                [self->elements removeObject:firmwareInfo];
                [self downloadFirmware];
            }
        }];
        [task resume];
    }else{
        dispatch_async(dispatch_get_main_queue(), ^{
            NSString *xmlFilePath=[NSString stringWithFormat:@"%@/%@",ROOTPATH,XMLNAME];
            [LongRange2DManager dismissGlobalHUD];
            NSURL *pathUrl = [NSURL fileURLWithPath:xmlFilePath];
            [[XMLHandler sharedAsRingHandler]getFirmwareInfoWithURL:pathUrl];
            self->alertControllIsPresenting = YES;
            UIAlertController* alert = [UIAlertController alertControllerWithTitle:nil
                                                                           message:NSLocalizedStringFromTable(@"Download firmware succeed", @"InfoPlist",Nil)
                                                                    preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                                  handler:^(UIAlertAction * action) {
                                                                  }];
            [alert addAction:defaultAction];
            [self presentViewController:alert animated:YES completion:^{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [NSThread sleepForTimeInterval:1.0];
                    self->alertControllIsPresenting = NO;
                    if (self->needPopToRoot) {
                        [self.navigationController popToRootViewControllerAnimated:YES];
                    }
                });
            }];
        });
    }
}

-(void)xmlDataDidEndDocument:(NSArray *)xmlElements{
    [elements removeAllObjects];
    if (firmwareMode==LongRange2DRelease) {
        for (FirmwareInfo *firmware in xmlElements) {
            if ([firmware.firmwareMode isEqualToString:@"release"]) {
                if ([[SystemSetting sharedSystemSetting] canUpdataFirmware:firmware.firmwareVersion]) {
                    [elements addObject:firmware];
                }
            }
        }
    }else{
        [elements addObjectsFromArray:xmlElements];
    }
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.tableView reloadData];
        [self getExistFirmwareName];
    });
}

-(void)getExistFirmwareName{
    [existFirmwares removeAllObjects];
    NSString *filePath = ROOTPATH;
    NSArray *firmwareNames = [fileManager subpathsOfDirectoryAtPath:filePath error:nil];
    for (NSString *firmwareName in firmwareNames) {
        if ([[firmwareName pathExtension]isEqualToString:@"bin"]) {
            [existFirmwares addObject:firmwareName];
        }
    }
}


#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)sectionred{
    return elements.count ;
}

-(CGFloat)tableView:(UITableView *)tv heightForRowAtIndexPath:(nonnull NSIndexPath *)indexPath{
    return 44;
}

- (UITableViewCell *)tableView:(UITableView *)tv cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    UITableViewCell *cell = [tv dequeueReusableCellWithIdentifier:@"UserFilesCell" forIndexPath:indexPath];
    FirmwareInfo *firmwareinfo=[elements objectAtIndex:indexPath.row];
    NSString *fileName =  firmwareinfo.firmwareName;
    if (![existFirmwares containsObject:fileName]) {
        cell.textLabel.textColor = [UIColor redColor];
    }else{
        cell.textLabel.textColor = [UIColor blackColor];
    }
    cell.textLabel.text = fileName;
    cell.accessoryType = UITableViewCellAccessoryNone;
    if ([fileName isEqualToString:selectFirmware]){
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }else{
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    return cell;
}

-(void)tableView:(UITableView *)tv didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (elements.count != 0 ) {
        FirmwareInfo *firmwareinfo=[elements objectAtIndex:indexPath.row];
        NSString *fileName =  firmwareinfo.firmwareName;
        selectFirmware = fileName;
        [self getExistFirmwareName];
        [tableView reloadData];
        [self buttonStatusMethod];
    }
}

- (void)buttonStatusMethod {
    for (FirmwareInfo *firmwareinfo in elements) {
        if ([firmwareinfo.firmwareName isEqualToString:selectFirmware]){
            self.doneButton.hidden = NO;
            return;
        }else{
            self.doneButton.hidden = YES;
        }
    }
}

- (IBAction)onClickUpdataFrimwareButton:(id)sender {
    [self getExistFirmwareName];
    if (![existFirmwares containsObject:selectFirmware]) {
        self->alertControllIsPresenting = YES;
        UIAlertController* alert = [UIAlertController alertControllerWithTitle:NSLocalizedStringFromTable(@"Warning", @"InfoPlist",Nil)
                                                                       message:NSLocalizedStringFromTable(@"No available firmware for update please press Sync button to download from server.", @"InfoPlist",Nil)
                                                                preferredStyle:UIAlertControllerStyleAlert];

        UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:NSLocalizedStringFromTable(@"Confirm", @"InfoPlist",Nil) style:UIAlertActionStyleDefault
                                                              handler:^(UIAlertAction * action) {
                                                              }];

        [alert addAction:defaultAction];
        [self presentViewController:alert animated:YES completion:^{
            dispatch_async(dispatch_get_main_queue(), ^{
                [NSThread sleepForTimeInterval:1.0];
                self->alertControllIsPresenting = NO;
                if (self->needPopToRoot) {
                    [self.navigationController popToRootViewControllerAnimated:YES];
                }
            });
        }];
        return;
    }
    if (!selectFirmware || [selectFirmware isEqualToString:@""]) {
        return;
    }
    NSString* filePath = [[NSHomeDirectory() stringByAppendingPathComponent:@"Documents"] stringByAppendingPathComponent:selectFirmware];
    NSData *fileFata = [fileManager contentsAtPath:filePath];
    if (_longRange2DManager.isConnected) {
        pregressHUD = [LongRange2DManager showProgressBarHUDWithTitle:@"Update Firmware..."];
        [CATransaction commit];
    }
    [_firmwareUpdateManager updateFirmwareWithFileName:selectFirmware fileData:fileFata result:^(BOOL result) {
        [LongRange2DManager dismissGlobalHUD];
        [CATransaction commit];
        NSLog(@"result : %d", result);
        if (result == NO) {
            self->alertControllIsPresenting = YES;
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Update Firmware" message:@"Update Firmware Failed!.Please Try Again." preferredStyle:(UIAlertControllerStyleAlert)];
            UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            }];
            [alertController addAction:action];
            [self presentViewController:alertController animated:YES completion:^{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [NSThread sleepForTimeInterval:1.0];
                    self->alertControllIsPresenting = NO;
                    if (self->needPopToRoot) {
                        [self.navigationController popToRootViewControllerAnimated:YES];
                    }
                });
            }];
        }else{
            self->alertControllIsPresenting = YES;
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Update Firmware" message:@"Update Firmware Success!" preferredStyle:(UIAlertControllerStyleAlert)];
            UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            }];
            [alertController addAction:action];
            [self presentViewController:alertController animated:YES completion:^{
                dispatch_async(dispatch_get_main_queue(), ^{
                    [NSThread sleepForTimeInterval:1.0];
                    self->alertControllIsPresenting = NO;
                    if (self->needPopToRoot) {
                        [self.navigationController popToRootViewControllerAnimated:YES];
                    }
                });
            }];
        }
    } progress:^(NSProgress *progress) {
        dispatch_async(dispatch_get_main_queue(), ^{
            if (progress.totalUnitCount != 0) {
                float pro = (float)progress.completedUnitCount/(float)progress.totalUnitCount;
                self->pregressHUD.progress = pro;
            }
        });
    }];
}
#pragma mark - Reader Event Handler Methods
- (void)updateDeviceState:(LongRange2DResultCode)error {
    NSLog(@"ResultCode : %02x",(char)error);
}
- (void)changedActionState:(LongRange2DCommandType)action resultCode:(NSInteger)resultCode {

}
- (void)LongRange2DConnected:(BOOL)isConnected{
    if (!isConnected) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [LongRange2DManager dismissGlobalHUD];
            if (self->alertControllIsPresenting) {
                self->needPopToRoot = YES;
            }else {
                self->needPopToRoot = NO;
                [self.navigationController popToRootViewControllerAnimated:YES];
            }
        });
    }else {
        needPopToRoot = NO;
    }
}
- (void)receivedData:(NSData*)data{
    [_firmwareUpdateManager rX:data];
}
@end
