//
//  XMLHandler.m
//  AsCameraScan
//
// Created by Asterisk.Inc on 2018/4/27.
// Copyright © 2018年 Asterisk.Inc. All rights reserved.
//

#import "XMLHandler.h"
#import "FirmwareInfo.h"
@implementation XMLHandler{
    NSMutableArray *xmlElements;
    NSString *elementType;
    NSMutableString *fwFileName;
    NSMutableString *version;
    FirmwareInfo *firmwareInfo;
}
static XMLHandler * xmlHandler;

+ (XMLHandler *)sharedAsRingHandler{
    if (!xmlHandler) {
        xmlHandler = [[XMLHandler alloc] init];
    }
    return xmlHandler;
}

- (instancetype)init
{
    self = [super init];
    if (self) {
    }
    return self;
}
-(void)getFirmwareInfoWithURL:(NSURL *)url{
    xmlElements=[[NSMutableArray alloc]init];
    NSXMLParser *xmlParser=[[NSXMLParser alloc]initWithContentsOfURL:url];
    [xmlParser setDelegate:self];
    [xmlParser parse];
}
#pragma mark - NSXMLParserDelegate

-(void)parserDidStartDocument:(NSXMLParser *)parser{
    
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary<NSString *,NSString *> *)attributeDict{
    elementType=elementName;
    fwFileName=[[NSMutableString alloc] init];
    version=[[NSMutableString alloc] init];
    if ([elementName isEqualToString:@"Fw"]) {
        firmwareInfo=[[FirmwareInfo alloc]init];
        firmwareInfo.firmwareMode=[attributeDict objectForKey:@"status"];
    }
}

-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName{
    if ([elementName isEqualToString:@"FwFileName"]) {
        firmwareInfo.firmwareName=[fwFileName stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    }else if ([elementName isEqualToString:@"Version"]){
        firmwareInfo.firmwareVersion=[version stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    }else if ([elementName isEqualToString:@"Fw"]){
        [xmlElements addObject:firmwareInfo];
    }
    
}

-(void)parserDidEndDocument:(NSXMLParser *)parser{
    if (self.delegate&&[self.delegate respondsToSelector:@selector(xmlDataDidEndDocument:)]) {
        [self.delegate xmlDataDidEndDocument:xmlElements];
    }
}
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string{
    if ([elementType isEqualToString:@"FwFileName"]) {
        [fwFileName appendString:string];
    }else if ([elementType isEqualToString:@"Version"]){
        [version appendString:string];
    }
}
@end
