//
//  LongRange2DManager.h
//  LongRange2DDemo
//
//  Created by mac on 2018/12/24.
//  Copyright © 2018年 zyl. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <LongRange2DSDK/LongRange2DSDK.h>
#import <MBProgressHUD/MBProgressHUD.h>

@protocol LongRange2DManagerDelegate <NSObject>

@optional
- (void)LongRange2DConnected:(BOOL)isConnected;
- (void)updateDeviceState:(LongRange2DResultCode)error;
- (void)changedActionState:(LongRange2DCommandType)action
                resultCode:(NSInteger)resultCode;
- (void)receivedBarcodeString:(NSString *)barodeString
                  barcodeType:(LongRange2DBarcodeTypeOptions)barcodeType;
- (void)receivedBarcodeData:(NSData *)barcodeData
                barcodeType:(LongRange2DBarcodeTypeOptions)barcodeType;
- (BOOL)onAsReaderTriggerKeyEvent:(BOOL)status;
- (void)batteryStatus:(int)status;
- (void)receivedData:(NSData*)data;
@end


@interface LongRange2DManager : NSObject<LongRange2DDelegate>
@property (strong, nonatomic) MBProgressHUD *HUD;

@property (assign, nonatomic) BOOL isConnected;
@property (strong, nonatomic) id <LongRange2DManagerDelegate> delegate;
@property (nonatomic, assign) BOOL centerDecoding;

+ (LongRange2DManager *)sharedLongRange2DManager;
+ (MBProgressHUD *)showGlobalProgressHUDWithTitle:(NSString *)title;
+ (MBProgressHUD *)showProgressBarHUDWithTitle:(NSString *)title;
+ (void)dismissGlobalHUD;

- (NSString *)getSDKVersion;
- (NSString *)getDeviceModel;
- (NSString *)getAddress;

- (void)startMonitoringBattery:(BOOL)isStart;

- (void)setBeep:(LongRange2DBeepState)beepState;
- (void)setVibrator:(LongRange2DVibratorState)vibratorState;
- (void)setSleepTime:(int)sleepTime;
- (void)setAutoOffTime:(int)autoOffTime;
- (void)setScannerTimeOut:(int)scannerTimeOut;

- (LongRange2DBeepState)getBeep;
- (LongRange2DVibratorState)getVibrator;
- (int)getSleepTime;
- (int)getAutoOffTime;
- (int)getScannerTimeOut;

- (LongRange2DCommandType)getAction;
- (NSString *)getSerialNumber;
- (NSString *)getFirmwareVersion;

- (LongRange2DResultCode)startScan;
- (LongRange2DResultCode)stopScan;
- (LongRange2DResultCode)setBarcodeParam:(LongRange2DParamValue *)paramData;
- (LongRange2DParamValue *)getBarcodeParam:(LongRange2DParamNameOptions)paramName;
- (LongRange2DResultCode)startBeepWithBeepTime:(int)beepTime;
- (LongRange2DResultCode)startVibratorWithVibratorTime:(int)vibratorTime;
- (LongRange2DResultCode)setDefaultScannerPrama;
- (NSString *)getMessageWithResultCode:(LongRange2DResultCode)resultCode;
- (BOOL)sendData:(NSData*)data;
@end


