//
//  SystemSetting.m
//  AsReaderLR
//
//  Created by mac on 2017/8/7.
//  Copyright © 2017年 asterisk. All rights reserved.
//
#import "SystemSetting.h"
#import "LongRange2DManager.h"
#define ISNOTFIRSTUSED          @"IsNotFirtUsed"
#define BEEP                    @"Beep"
#define VIBRATOR                @"Vibrator"
#define BEEPTIME                @"BeepTime"
#define VIBRATORTIME            @"VibratorTime"
#define SLEEPTIME               @"SleepTime"
#define AUTOOFFTIME             @"AutoOffTime"
#define SCANNERTIMEOUT          @"ScannerTimeOut"
#define BARCODEDATA             @"BarcodeData"
#define MAPTAGS                 @"MapTags"
#define BARCODEPARAMDATA        @"barcodeParamData"
#define BARCODERESCANTIME       @"BarcodeRescanTime"
#define BATTERYINTERVAL         @"batteryInterval"
#define DECODINGINDEX           @"decodingIndex"
#define CENTERDECODING          @"centerDecoding"
#define CENTERDECODINGFIRMWAREVERSION @"1.8.1"
#define NEEDUPDATEFIRMWAREVERSION @"1.10.4"
@implementation SystemSetting{
    NSUserDefaults * m_userDefaults;
}

static SystemSetting * systemSetting;

+ (SystemSetting *)sharedSystemSetting{
    if (!systemSetting) {
        systemSetting = [[SystemSetting alloc] init];
    }
    return systemSetting;
}

- (instancetype)init
{
    self = [super init];
    if (self) {
        m_userDefaults = [NSUserDefaults standardUserDefaults];
    }
    return self;
}

- (void)setNotFirstUsed:(BOOL)isFirst{
    [m_userDefaults setBool:isFirst forKey:ISNOTFIRSTUSED];
    [m_userDefaults synchronize];
}
- (BOOL)getNotFirstUsed{
    return [m_userDefaults boolForKey:ISNOTFIRSTUSED];
}


- (void)setBeep:(int)beepType{
    [m_userDefaults setInteger:beepType forKey:BEEP];
    [m_userDefaults synchronize];
}
- (void)setVibrator:(int)vibratorType{
    [m_userDefaults setInteger:vibratorType forKey:VIBRATOR];
    [m_userDefaults synchronize];
}
- (void)setSleepTime:(int)sleepTimeValue{
    [m_userDefaults setInteger:sleepTimeValue forKey:SLEEPTIME];
    [m_userDefaults synchronize];
}
- (void)setScannerTiemOut:(int)scannerTiemOutValue{
    [m_userDefaults setInteger:scannerTiemOutValue forKey:SCANNERTIMEOUT];
    [m_userDefaults synchronize];
}
- (void)setMapTags:(NSDictionary *)mapTags{
    NSData *data = [NSKeyedArchiver archivedDataWithRootObject:mapTags];
    [m_userDefaults setObject:data forKey:MAPTAGS];
     data = nil;
    [m_userDefaults synchronize];
}
- (void)setBarcodeParamData:(NSArray *)barcodeParamData{
    NSData *barcodeData = [NSKeyedArchiver archivedDataWithRootObject:barcodeParamData];
    [m_userDefaults setObject:barcodeData forKey:BARCODEPARAMDATA];
    barcodeData = nil;
    [m_userDefaults synchronize];
}
 

- (int)getBeep{
    return (int)[m_userDefaults integerForKey:BEEP];
}
- (int)getVibrator{
    return (int)[m_userDefaults integerForKey:VIBRATOR];
}
- (int)getSleepTime{
    return (int)[m_userDefaults integerForKey:SLEEPTIME];
}
- (int)getScannerTimeOut{
    return (int)[m_userDefaults integerForKey:SCANNERTIMEOUT];
}

- (void)setAutoOffTime:(int)autoOffTime{
    [m_userDefaults setInteger:autoOffTime forKey:AUTOOFFTIME];
    [m_userDefaults synchronize];
}
- (int)getAotuOffTime{
    return (int)[m_userDefaults integerForKey:AUTOOFFTIME];
}


- (NSArray *)getBarcodeData{
    NSData *data = [m_userDefaults objectForKey:BARCODEDATA];
    NSArray * array = [NSKeyedUnarchiver unarchiveObjectWithData:data];
    return array;
}
- (NSDictionary *)getMapTags{
    NSData *data = [m_userDefaults objectForKey:MAPTAGS];
    NSDictionary * dic = [NSKeyedUnarchiver unarchiveObjectWithData:data];
    return dic;
}
- (NSArray *)getBarcodeParamData{
    NSData *tokenObject = [m_userDefaults objectForKey:BARCODEPARAMDATA];
    NSArray * array = [NSKeyedUnarchiver unarchiveObjectWithData:tokenObject];
    return array;
}

- (void)setBeepTime:(int)beepTime{
    [m_userDefaults setInteger:beepTime forKey:BEEPTIME];
    [m_userDefaults synchronize];
}
- (int)getBeepTime{
    return (int)[m_userDefaults integerForKey:BEEPTIME];
}

- (void)setVibratorTime:(int)vibratorTime{
    [m_userDefaults setInteger:vibratorTime forKey:VIBRATORTIME];
    [m_userDefaults synchronize];
}
- (int)getVibratorTime{
    return (int)[m_userDefaults integerForKey:VIBRATORTIME];
}
- (void)setBarcodeReScanTime:(int)barcodeReScanTime{
    [m_userDefaults setInteger:barcodeReScanTime forKey:BARCODERESCANTIME];
    [m_userDefaults synchronize];
}
- (int)getBarcodeReScanTime{
    return (int)[m_userDefaults integerForKey:BARCODERESCANTIME];
}
- (void)setBarcodeData:(NSArray *)barcodeData{
    NSData *data = [NSKeyedArchiver archivedDataWithRootObject:barcodeData];
    [m_userDefaults setObject:data forKey:BARCODEDATA];
    data = nil;
    [m_userDefaults synchronize];
}
- (void)setBatteryInterval:(NSString *)batteryInterval {
    [m_userDefaults setObject:batteryInterval forKey:BATTERYINTERVAL];
    [m_userDefaults synchronize];
}

- (NSString *)getBatteryInterval {
    NSString *batteryInterval = [m_userDefaults stringForKey:BATTERYINTERVAL];
    if (batteryInterval == nil || [batteryInterval isEqualToString:@""]) {
        batteryInterval = DEFAULT_BATTERY_INTERVAL;
    }
    return batteryInterval;
}

- (void)setDecodingIndex:(NSInteger)index{
    [m_userDefaults setInteger:index forKey:DECODINGINDEX];
    [m_userDefaults synchronize];
}

- (NSInteger)getDecodingIndex{
    return [m_userDefaults integerForKey:DECODINGINDEX];
}

- (void)setCenterDecoding:(BOOL)centerDecoding{
    [m_userDefaults setBool:centerDecoding forKey:CENTERDECODING];
    [m_userDefaults synchronize];
}

- (BOOL)getCenterDecoding{
    return [m_userDefaults boolForKey:CENTERDECODING];
}

- (BOOL)canUseCenterDecoding:(NSString *)firmwareVersion{
    NSMutableArray *motoVersion = [NSMutableArray arrayWithArray:[CENTERDECODINGFIRMWAREVERSION componentsSeparatedByString:@"."]];
    if (!firmwareVersion || [firmwareVersion isEqualToString:@""]) {
        return NO;
    }
    NSString *currentVersionStr = [firmwareVersion componentsSeparatedByString:@"-"].lastObject;
    NSMutableArray *currentVersion = [NSMutableArray arrayWithArray:[currentVersionStr componentsSeparatedByString:@"."]];
    
    if(currentVersion.count > motoVersion.count){
        for (int i = (int)motoVersion.count; i<currentVersion.count; i++) {
            [motoVersion addObject:@"0"];
        }
    }else{
        for (int i = (int)currentVersion.count; i<motoVersion.count; i++) {
            [currentVersion addObject:@"0"];
        }
    }

    for (int i = 0; i<motoVersion.count; i++ ) {
        int current = [[currentVersion objectAtIndex:i] intValue];
        int moto = [[motoVersion objectAtIndex:i] intValue];
        if(current < moto){
            return NO;
        }else if(current > moto){
            return YES;
        }
    }
    return YES;
}

- (BOOL)canUpdataFirmware:(NSString *)firmwareVersion{
    if (firmwareVersion == nil || [@"" isEqualToString:firmwareVersion]) {
        return NO;
    }
    NSArray *versionArray = [firmwareVersion componentsSeparatedByString:@"."];
    if (versionArray.count == 0) {
        return NO;
    }
    NSString *versionFirstString = [versionArray firstObject];
    if (versionFirstString == nil || [@"" isEqualToString:versionFirstString]) {
        return NO;
    }

    NSString *currentStr = [[LongRange2DManager sharedLongRange2DManager] getFirmwareVersion];
    currentStr = [currentStr componentsSeparatedByString:@"-"].lastObject;
    if (currentStr == nil || [@"" isEqualToString:currentStr]) {
        return NO;
    }
    NSArray *currentArray = [currentStr componentsSeparatedByString:@"."];
    if (currentArray.count == 0) {
        return NO;
    }
    NSString *currentFirstString = [currentArray firstObject];
    if (currentFirstString == nil || [@"" isEqualToString:currentFirstString]) {
        return NO;
    }
    if ([currentFirstString isEqualToString:@"1"] && [versionFirstString intValue] < 3) {
        return YES;
    }
    if ([currentFirstString isEqualToString:@"3"] && [versionFirstString intValue] >= 3) {
        return YES;
    }
    return NO;
}

- (BOOL)needUpdateFirmwareVersion:(NSString *)firmwareVersion{
    NSMutableArray *motoVersion = [NSMutableArray arrayWithArray:[NEEDUPDATEFIRMWAREVERSION componentsSeparatedByString:@"."]];
    if (!firmwareVersion || [firmwareVersion isEqualToString:@""]) {
        return NO;
    }
    NSString *currentVersionStr = [firmwareVersion componentsSeparatedByString:@"-"].lastObject;
    NSMutableArray *currentVersion = [NSMutableArray arrayWithArray:[currentVersionStr componentsSeparatedByString:@"."]];
    
    if(currentVersion.count > motoVersion.count){
        for (int i = (int)motoVersion.count; i<currentVersion.count; i++) {
            [motoVersion addObject:@"0"];
        }
    }else{
        for (int i = (int)currentVersion.count; i<motoVersion.count; i++) {
            [currentVersion addObject:@"0"];
        }
    }

    for (int i = 0; i<motoVersion.count; i++ ) {
        int current = [[currentVersion objectAtIndex:i] intValue];
        int moto = [[motoVersion objectAtIndex:i] intValue];
        if(current < moto){
            return YES;
        }else if(current > moto){
            return NO;
        }
    }
    return NO;
}
@end
