//
//  UpdataFirmwareViewController.m
//  LongRange2DDemo
//
//  Created by mac on 2019/1/7.
//  Copyright © 2019年 zyl. All rights reserved.
//

#import "UpdateFirmwareViewController.h"
#import "MBProgressHUD.h"
@interface UpdateFirmwareViewController ()

@end

@implementation UpdateFirmwareViewController{
    LongRange2DManager *_longRange2DManager;
    NSMutableArray     *_filePathArray;
    NSFileManager      *_fileManager;
    NSString           *_selectFile;
    NSString           *_documentPath;
    NSIndexPath        *_selectIndexPath;
    MBProgressHUD      *pregressHUD;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    _longRange2DManager = [LongRange2DManager sheardLongRange2DManager];
    _filePathArray = [[NSMutableArray alloc] init];
    _fileManager = [NSFileManager defaultManager];
    NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    _documentPath = [documentPaths objectAtIndex:0];
    [_filePathArray addObjectsFromArray:[_fileManager contentsOfDirectoryAtPath:_documentPath error:nil]];
}
- (void)viewDidAppear:(BOOL)animated{
    [_longRange2DManager  setDelegate:self];
    [LongRange2DManager dismissGlobalHUD];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [_longRange2DManager  setDelegate:nil];
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return _filePathArray.count;
}

#pragma mark - UITableViewDelegate
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString *cellIdentifier = @"FileCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if(!cell){
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    NSString * fileName = [NSString stringWithFormat:@"%@",[_filePathArray objectAtIndex:indexPath.row]];
    cell.textLabel.text = fileName;
    if (_selectIndexPath && _selectIndexPath  == indexPath) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    return cell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    UITableViewCell *cellOld = [tableView cellForRowAtIndexPath:_selectIndexPath];
    cellOld.accessoryType = UITableViewCellAccessoryNone;
    
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    _selectIndexPath = indexPath;
    _selectFile = [NSString stringWithFormat:@"%@",[_filePathArray objectAtIndex:indexPath.row]];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    
}

- (IBAction)onClickUpdataFrimwareButton:(id)sender {
    if (!_selectFile || [_selectFile isEqualToString:@""]) {
        return;
    }
    NSString *filePath = [NSString stringWithFormat:@"%@/%@",_documentPath,_selectFile];
    NSFileManager *fileManager=[NSFileManager defaultManager];
    NSDictionary *dict = [fileManager attributesOfItemAtPath:filePath error:nil];
    unsigned long long size = [dict fileSize];
    NSData *data = [fileManager contentsAtPath:filePath];
    if (_longRange2DManager.mLongRange2D.mLongRange2DDevice.isConnect) {
        pregressHUD = [LongRange2DManager showProgressBarHUDWithTitle:@"Update Firmware..."];
        [CATransaction commit];
    }
    [_longRange2DManager.mLongRange2D updateFirmwareWithFileName:_selectFile fileData:data resultCode:^(ResultCode resultCode) {
        [LongRange2DManager dismissGlobalHUD];
        NSLog(@"ResultCode : %02x  ",resultCode);
        if (resultCode !=  ResultNoError) {
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Update Firmware" message:[NSString stringWithFormat:@"%@.Please Try Again.",[self->_longRange2DManager.mLongRange2D  getMessageWithResultCode:resultCode]] preferredStyle:(UIAlertControllerStyleAlert)];
            UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            }];
            [alertController addAction:action];
            [self presentViewController:alertController animated:YES completion:nil];
        }else{
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"Update Firmware" message:@"Update Firmware Success!" preferredStyle:(UIAlertControllerStyleAlert)];
            UIAlertAction * action = [UIAlertAction actionWithTitle:@"OK" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
            }];
            [alertController addAction:action];
            [self presentViewController:alertController animated:YES completion:nil];
        }
    } progress:^(NSProgress *progress) {
         dispatch_async(dispatch_get_main_queue(), ^{
            if (progress.totalUnitCount != 0) {
                float pro = (float)progress.completedUnitCount/(float)progress.totalUnitCount;
                self->pregressHUD.progress = pro;
            }
         });
    }];
}
#pragma mark - Reader Event Handler Methods
- (void)updateDeviceState:(ResultCode)error {
    NSLog(@"ResultCode : %02x",error);
}
- (void)changedActionState:(CommandType)action resultCode:(NSInteger)resultCode {
    
}
- (void)LongRange2DConnected:(BOOL)isConnected{
    if (!isConnected) {
        dispatch_async(dispatch_get_main_queue(), ^{
            self->_longRange2DManager.mLongRange2D = nil;
            [LongRange2DManager dismissGlobalHUD];
            [self.navigationController popToRootViewControllerAnimated:YES];
        });
    }
}
@end
